import Vue from 'vue'
const _this = new Vue();
/* eslint-disable */
export default {
    param: {
        markers: [],
        layers: [],
        labels: [],
        Intertime: null
    },
    Img: {
        "dataEdit_marker":require("../../assets/images/img/dataEdit_marker.png"),
    },
    /**
     * [setBestMap description]
     * @DateTime 2019-03-05T16:25:13+0800
     * @param    {geojson}                lnglats
     * @param    {object}                 options
     */
    addrasterLayer: function(map, tileId, tileUrl, layerId) {
        var trafficLayerStyle = {
            "id": tileId,
            "type": "raster",
            "source": {
                "type": "raster",
                "tiles":[tileUrl],
                "tileSize":256
            }
        }
        map.addLayer(trafficLayerStyle, layerId);
    },
    addTmsTileLayer: function(map, options, layerId){
        var trafficLayerStyle = {
            'id': options.id,
            'source-layer': options.sourceLayer,
            'type': 'raster',
            'source': {
                'type': 'raster',
                'scheme':'tms',
                'tiles': [
                    options.tmsUrl
                ],
                'tileSize':options.tileSize
            }
        }
        map.addLayer(trafficLayerStyle, layerId)
    },
    addWmsTileLayer: function(map, options, layerId){
        var trafficLayerStyle = {
            'id': options.id,
            'type': 'raster',
            'source': {
                'type': 'raster',
                'tiles': [
                    options.wmsUrl
                ],
                'tileSize':options.tileSize
            },
            'paint': {
                "raster-opacity": options.opacity//图层显示透明度
                //raster-hue-rotate 设置该值以后，显示的颜色就不会是图层样式里面设置的颜色，所以最好不要设置
                //"raster-hue-rotate": 60,//在色轮上旋转色相的角度
            }
        }
        map.addLayer(trafficLayerStyle, layerId)
    },
    removerasterLayer: function(map, tileId) {
        map.removeLayerAndSource(tileId);
    },
    setBestMap : function(lnglats,options) {
        options =  Object.assign({
            top:60,
            bottom:0,
            left:0,
            right:0,
            maxZoom:17,
            pitch:60,
            maps:map
        }, options);
        if (lnglats.length>0) {
            options.maps.fitBounds(turf.bbox(turf.points(lnglats)), {
                padding: {top: options.top, bottom:options.bottom, left:options.left, right: options.right},
                maxZoom:options.maxZoom,
                pitch:options.pitch
            });
        }
    },
    addNavigationControl: function(mapObj, options){
        mapObj.addControl(new mapboxgl.NavControl(options));
    },
    addMapMarker: function(options, callback) {
        options.maps = options.map //地图对象
        let map = options.map
        var that = this;
        options = Object.assign({
            lng: '', //经度
            lat: '', //纬度
            markerType: 'all', //图标类型
            imgType: '1', //图片
            imgsrc: "", //图片地址
            width: 24, //容器宽度
            height: 24, //容器高度
            title: '', //marker名称
            item: {}, //marker信息
            html: "", //悬浮显示html
            mouse: false //鼠标移动移出
        }, options);

        /* console.log(options); */
        var img = this.Img[options.imgType];
        img = options.imgsrc ? options.imgsrc : img;
        if(options.lng && options.lat) {
            const html = document.createElement('div');
            html.title = options.title;
            if(options.markerType == 'c3') {
                html.className = "animation";
                html.style.cssText = ' background-image:url(' + img + ') center center  100% ;width:' + options.width + 'px;height:' + options.height + 'px;cursor:pointer;background-size: cover;'

            } else {
                html.style.cssText = ' background:url(' + img + ') center center 100% no-repeat;width:' + options.width + 'px;height:' + options.height + 'px;cursor:pointer;'
                html.style.backgroundImage = 'url("' + img + '")';
                html.style.backgroundPosition = "center center";
                html.style.backgroundRepeat = "no-repeat";
                html.style.backgroundSize = "100%";
                html.style.width = options.width;
                html.style.height = options.height;
                html.style.cursor = "pointer";
            };
            const marker = new mapboxgl.Marker(html)
                .setLngLat([options.lng, options.lat])
                .addTo(options.maps);
            marker.item = options.item;

            html.addEventListener('click', function(e) {
                if(callback) {
                    callback(options.item, e);
                };

            });
            if(options.mouse) {
                var status = true;
                if(!options.html) {
                    status = false;
                    _this.$message.error('悬浮内容缺失');
                }

                if(status) {
                    var id = "id_" + "_mouseover_" + new Date().getTime();
                    html.addEventListener("mouseover", function(e) {
                        that.addPopup(options.html, options.lng, options.lat, id)
                    })
                    html.addEventListener("mouseout", function(e) {
                        that.removeMarkers(id)
                    })
                }
            }
            const obj = {
                marker: marker,
                type: options.markerType,
                id: options.id,
            };
            this.param.markers.push(obj);
        } else {
            _this.$message.error('经纬度缺失');
        };

    },
    addmapMarker : function(options,callback,dragendCallback) {
        options =  Object.assign({
            maps:map,//地图对象
            lng:'',//经度
            lat:'',//纬度
            markerType:'all',//图标类型
            imgType:'poi',//图片
            width:24,//容器宽度
            height:24,//容器高度
            title:'',//marker名称
            item:{},//marker信息
            ext:{},//扩展信息
            id:''
        }, options);

        const img = this.Img[options.imgType] ? this.Img[options.imgType] : options.imgType.indexOf('0') != -1 ? this.Img['tz_mrsb0']:this.Img['tz_mrsb'] ;
        if (options.lng && options.lat) {
            const html = document.createElement('div');
            html.title = options.title;
            if (options.markerType=='c3') {
                html.className = "animation";
                html.style.cssText = ' background-image:url('+img+');width:'+options.width+'px;height:'+options.height+'px;cursor:pointer;background-size: cover;'
            }else{
                html.style.cssText = ' background:url('+img+') no-repeat;width:'+options.width+'px;height:'+options.height+'px;cursor:pointer;background-size: cover;'
            }
            const marker = new mapboxgl.Marker(html)
                .setLngLat([options.lng,options.lat])
                .addTo(options.maps);
            html.addEventListener('click',function(e){
                if (callback) {
                    callback(e, options.item, options.ext ,marker);
                };
            });
            if( dragendCallback ){
                marker.on("dragend", function(e) {
                    dragendCallback(e,marker);
                    marker.setDraggable(false);
                });
            }
            const obj = {
                marker:marker,
                type:options.markerType,
                id:options.id
            };
            this.param.markers.push(obj);
        }else{
            // _this.$message.error('经纬度缺失');
        }
    },
    addmapMarkerRotate : function(options,callback,dragendCallback) {
        options =  Object.assign({
            maps:map,//地图对象
            lng:'',//经度
            lat:'',//纬度
            markerType:'all',//图标类型
            imgType:'poi',//图片
            width:24,//容器宽度
            height:24,//容器高度
            title:'',//marker名称
            item:{},//marker信息
            ext:{},//扩展信息
            id:''
        }, options);

        const img = this.Img[options.imgType];
        if (options.lng && options.lat) {
            const html = document.createElement('div');
            const htmlimg = document.createElement('div');
            html.className = 'bearing';
            html.setAttribute("rid",options.id)
            let markertype = options.imgType.indexOf('-no') == -1? 'yes':'no';
            html.setAttribute("markertype",markertype)
            html.setAttribute("turnType",options.item.turnType)
            html.title = options.title;
            html.style.cssText = 'width:'+options.width+'px;height:'+options.height+'px;cursor:pointer;'
            htmlimg.style.cssText = 'background:url('+img+') no-repeat;width:'+options.width+'px;height:'+options.height+'px;cursor:pointer;background-size: cover;transform:rotate('+options.bearing+'deg);'
            html.appendChild(htmlimg)
            const marker = new mapboxgl.Marker(html)
                .setLngLat([options.lng,options.lat])
                .addTo(options.maps);
            html.addEventListener('click',function(e){
                if (callback) {
                    callback(e, options.item, options.ext ,marker);
                    e.preventDefault();
                };
            });
            if( dragendCallback ){
                marker.on("dragend", function(e) {
                    dragendCallback(e,marker);
                    marker.setDraggable(false);
                });
            }
            const obj = {
                marker:marker,
                type:options.markerType,
                id:options.id
            };
            this.param.markers.push(obj);
        }else{
            _this.$message.error('经纬度缺失');
        }
    },
    addmapMarkerHighlightCircle : function(options,callback,dragendCallback) {
        options =  Object.assign({
            maps:map,//地图对象
            lng:'',//经度
            lat:'',//纬度
            markerType:'all',//图标类型
            imgType:'poi',//图片
            width:24,//容器宽度
            height:24,//容器高度
            title:'',//marker名称
            item:{},//marker信息
            ext:{},//扩展信息
            id:''
        }, options);
        const img = this.Img[options.imgType];
        if (options.lng && options.lat) {
            const html = document.createElement('div');
            const quan = document.createElement('span');
            html.appendChild(quan);
            html.title = options.title;
            html.className = 'highlightCircle';
            html.setAttribute("crossgeom",options.item.geom);
            html.style.cssText = 'border-radius: 50%;;width:'+options.width+'px;height:'+options.height+'px;cursor:pointer;background-size: cover;color:#fff;text-align: center;'
            quan.style.cssText = 'background:#fff;border-radius: 50%;;width:'+(options.width-10)+'px;height:'+(options.height-10)+'px;display: inline-block; margin-top:5px; border:1px solid #C0C0C0;'
            const marker = new mapboxgl.Marker(html)
                .setLngLat([options.lng,options.lat])
                .addTo(options.maps);
            html.addEventListener('click',function(e){
                if (callback) {
                    callback(e, options.item, options.ext);
                    e.stopPropagation()
                };
            });
            if( dragendCallback ){
                marker.on("dragend", function(e) {
                    dragendCallback(e,marker);
                    marker.setDraggable(false);
                });
            }
            const obj = {
                marker:marker,
                type:options.markerType,
                id:options.id
            };
            this.param.markers.push(obj);
        }else{
            _this.$message.error('经纬度缺失');
        }
    },
    addmapMarkerCircle : function(options,callback,dragendCallback) {
        options =  Object.assign({
            maps:map,//地图对象
            lng:'',//经度
            lat:'',//纬度
            markerType:'all',//图标类型
            imgType:'poi',//图片
            width:24,//容器宽度
            height:24,//容器高度
            title:'',//marker名称
            item:{},//marker信息
            ext:{},//扩展信息
            id:'',
            bgcolor:'#1296DB',
            zindex:1,//层级信息
        }, options);
        // console.log(options);
        const img = this.Img[options.imgType];
        if (options.lng && options.lat) {
            const html = document.createElement('div');
            html.title = options.title;
            html.style.cssText = ' background:'+options.bgcolor+';border-radius: 50%;;width:'+options.width+'px;height:'+options.height+'px;cursor:pointer;background-size: cover;color:#fff;text-align: center;line-height: '+options.height+'px;z-index: '+options.zindex+';'
            html.innerHTML = options.item.count;
            if( options.number ){
                html.innerHTML = options.number;
            }else{
                html.innerHTML = options.item.count;
            }
            
            const marker = new mapboxgl.Marker(html)
                .setLngLat([options.lng,options.lat])
                .addTo(options.maps);
            html.addEventListener('click',function(e){
                if (callback) {
                    callback(e, options.item, options.ext);
                };
            });
            if( dragendCallback ){
                marker.on("dragend", function(e) {
                    dragendCallback(e,marker);
                    marker.setDraggable(false);
                });
            }
            const obj = {
                marker:marker,
                type:options.markerType,
                id:options.id
            };
            this.param.markers.push(obj);
        }else{
            _this.$message.error('经纬度缺失');
        }
    },
    addmapMarkerDistance : function(options,callback) {
        options =  Object.assign({
            maps:map,//地图对象
            lng:'',//经度
            lat:'',//纬度
            markerType:'all',//图标类型
            imgType:'poi',//图片
            width:24,//容器宽度
            height:24,//容器高度
            title:'',//marker名称
            item:{},//marker信息
            ext:{},//扩展信息
            id:'',
            bgcolor:'#1296DB',
            zindex:1,//层级信息
        }, options);
        const img = this.Img[options.imgType];
        if (options.lng && options.lat) {
            const html = document.createElement('div');
            html.title = options.title;
            html.className = "distance";
            html.style.cssText = ' background:'+options.bgcolor+';color:#fff;text-align: center;padding: 5px 10px; border-radius: 3px;font-size: 12px;line-height: 18px;  top:20px; z-index: '+options.zindex+';'
            if( options.distance.indexOf("总长") == -1 ){
                html.innerHTML = options.distance;
            }else{
                html.innerHTML = options.distance+" <span style='border:1px solid #fff;cursor:pointer;padding: 0px 5.5px 1px; margin-right: -4px; margin-left: 4px;border-radius: 5px; font-size:12px;' >x</span>";
            }
            const marker = new mapboxgl.Marker(html).setLngLat([options.lng,options.lat]).addTo(options.maps);
            html.addEventListener('click',function(e){
                e.stopPropagation();
                if ( callback && e.target.tagName == "SPAN" ) {
                    callback(e, options.item, options.ext);
                };
            });
            const obj = {
                marker:marker,
                type:options.markerType,
                id:options.id
            };
            this.param.markers.push(obj);
        }else{
            _this.$message.error('经纬度缺失');
        }
    },
    addPopupGj: function (map,html, lng, lat, type, offset,className) {
		console.log(className)
	  	var offset = offset ? offset : [0, 0];
		var className = className ? className :'';
	  	var popup = new mapboxgl.Popup({ closeOnClick: false, offset: offset,className:className})
	  		.setLngLat([lng, lat])
	  		.setHTML(html)
	  		.addTo(map);
	  	var obj = {
	  		marker: popup,
	  		type: type
	  	}
	  	this.param.markers.push(obj)
	  },
    addPopup: function(map, html, lng, lat, type, id) {
        var popup = new mapboxgl.Popup({
            closeOnClick: false
        })
            .setLngLat([lng, lat])
            .setHTML(html)
            .addTo(map)
        var obj = {
            marker: popup,
            type: type,
            id: id,
        }
        this.param.markers.push(obj)
        return popup
    },
    addGeojsonPoint(options, callback){
        options = Object.assign({
            // 地图对象
            id: 'point',
            maps: map,
            data: {},
            // properties信息
            properties: {
                mag:3,
                title: 'point',
                // icon: 'harbor'
            }
        }, options)

        const features = []
        const feature = {
            'type': 'Feature',
            'geometry': options.data,
            'properties': options.properties,
        }
        features.push(feature)
        options.maps.addSource(options.id, {
            'type': 'geojson',
            'data': {
                'type': 'FeatureCollection',
                'features': features
            }
        });
        options.maps.on('click', options.id, callback);
    },
    addGeojsonPoints(options, callback){
        options = Object.assign({
            // 地图对象
            maps: map,
            data: data,
            // properties信息
            'properties': { mag:3 }
        }, options)

        const geojsonDatas = options.data
        const features = []
        for (const key in geojsonDatas) {
            const geojsonData = geojsonDatas[key]
            const feature = {
                'type': 'Feature',
                'geometry': geojsonData,
                'properties': options.properties,
            }
            features.push(feature)
        }
        options.maps.addSource('geojson-point', {
            'type': 'geojson',
            'data': {
                'type': 'FeatureCollection',
                'features': features
            }
        });
    },
    addmapLine(options, callback) {
        options = Object.assign({
            // 地图对象
            maps: map,
            type: 'line',
            id: 'line',
            data: '',
            color: '#77e6c6',
            strokeWeight: 4,
            opacity: 1,
            visibility: 'visible',
            // dasharray:[1,1],
            minzoom: 3,
            item: null,
            index: null
        }, options)
        //console.log(options)
        if(options.data && options.data !== ''){
            // console.log(options.data)
            options.maps.addLayer({
                "id": options.id,
                "type": "line",
                "source": {
                    "type": "geojson",
                    "data": {
                        "type": "Feature",
                        "properties": {},
                        "geometry":options.data
                    }
                },
                "layout": {
                    "line-join": "round",
                    "line-cap": "round"
                },
                "paint": {
                    "line-color": options.color,
                    "line-width": options.strokeWeight,
                    "line-opacity": options.opacity
                }
            });
            var obj = {
                type: options.type,
                layers: options.id
            }
            this.param.layers.push(obj)
            /* console.log(obj) */
            options.maps.on('click', options.id, function(e) {
                if (callback) {
                    callback(e, options.item, options.ext)
                }
            })
        }else{
            _this.$message.error('缺失数据');
        }
    },
    // clearTimer: function() {
    //   clearInterval(this.param.Intertime)
    // },
    setVisibility: function(visibility, type) {
        var layers = this.param.layers

        if (layers.length > 0) {
            for (var i = 0; i < layers.length; i++) {
                if (type) {
                    if (layers[i].type == type) {
                        map.setLayoutProperty(layers[i].layers, 'visibility', visibility)
                    }
                } else {
                    map.setLayoutProperty(layers[i].layers, 'visibility', visibility)
                }
            }
        }
    },

    addmapPolygon: function(options, callback) {
        options = Object.assign({
            maps: map, // 地图对象
            type: 'Polygon',
            id: 'Polygon',
            gons: [],
            color: 'red',
            opacity: 0.8,
            item: null,
            index: null
        }, options)

        if (options.gons.length == 0) {
            _this.$message.error('经纬度缺失')
            return
        }
        var geojson = {
            'type': 'Feature',
            'geometry': {
                'type': 'Polygon',
                'coordinates': [options.gons]
            }

        }

        options.maps.addLayer({
            'id': options.id,
            'type': 'fill',
            'source': {
                'type': 'geojson',
                'data': geojson
            },
            'maxzoom': 24,
            'paint': {
                'fill-color': options.color,
                'fill-outline-color': '#fff',
                'fill-opacity': 0.4
            }
        })
        var obj = {
            type: options.type,
            layers: options.id
        }

        this.param.layers.push(obj)
        options.maps.on('click', options.id, function() {
            if (callback) {
                callback(options.item, options.index)
            }
        })
    },

    addmapLabel: function(options, callback) {
        options = Object.assign({
            maps: map, // 地图对象
            lng: '', // 经度
            lat: '', // 纬度
            type: 'label',
            html: ''
        }, options)

        var marker = new mapboxgl.Marker(options.html)
            .setLngLat([options.lng, options.lat])
            .addTo(options.maps)

        var obj = {
            marker: marker,
            type: options.type
        }
        this.param.markers.push(obj)
    },

    clearTimer: function() {
        clearInterval(this.param.Intertime)
    },

    removeLayerAndSource: function(maps, id){
        maps.removeLayerAndSource(id)
    },

    removeLayers: function(maps, type) {
        var layers = this.param.layers
        var _index = []
        var k = 0
        if (layers.length > 0) {
            for (var i = 0; i < layers.length; i++) {
                if (type) {
                    if (layers[i].type === type) {
                        maps.removeLayerAndSource(layers[i].layers)
                        maps.removeLayerAndSource(layers[i].layers + 1)
                        maps.removeLayerAndSource(layers[i].layers + 'highlight')
                        _index.push(i)
                    }
                } else {
                    maps.removeLayerAndSource(layers[i].layers)
                    maps.removeLayerAndSource(layers[i].layers + 1)
                    maps.removeLayerAndSource(layers[i].layers + 'highlight')
                    _index.push(i)
                    // this.param.layers = []
                }
            }
            for (var j in _index) {
                layers.splice(_index[j] - k, 1)
                k++
            }
        }
    },

    minremoveLayers: function(type) {
        var layers = this.param.layers
        if (layers.length > 0) {
            for (var i = 0; i < layers.length; i++) {
                if (type) {
                    if (layers[i].type === type) {
                        minmap.removeLayerAndSource(layers[i].layers)
                    }
                } else {
                    minmap.removeLayerAndSource(layers[i].layers)
                    this.param.layers = []
                }
            }
        }
    },

    removeMarkers: function(type) {
        var _this = this
        var markers = this.param.markers
        var _index = []
        var k = 0
        if (markers.length > 0) {
            for (var i = 0; i < markers.length; i++) {
                if (type) {
                    if (markers[i].type === type) {
                        markers[i].marker.remove()
                        _index.push(i)
                    }
                } else {
                    markers[i].marker.remove()
                    this.param.markers = []
                    _index.push(i)
                }
            }
            for (var j in _index) {
                markers.splice(_index[j] - k, 1)
                k++
            }
        }
    },

    removeLabels: function () {
        var labels = this.param.labels
        if (labels.length > 0) {
            for (var i = 0; i < labels.length; i++) {
                labels[i].remove()
            }
            this.param.labels = []
        }
    },

    removeAll: function (mapObj) {
        this.removeLayers(mapObj)
        this.removeMarkers()
        this.removeLabels()
    },

    removeArray(_arr, _obj) {
        var length = _arr.length
        for (var i = 0; i < length; i++) {
            if (_arr[i] === _obj) {
                if (i === 0) {
                    _arr.shift()
                    return _arr
                } else if (i === length - 1) {
                    _arr.pop()
                    return _arr
                } else {
                    _arr.splice(i, 1)
                    return _arr
                }
            }
        }
    },
    easeTo: function (map, options, eventData) {
        options = Object.assign({
            center: map_config.MAP_CENTER,
            pitch: 0,
            bearing: 30,
            //飞行速度
            speed:0.8
        }, options)
        map.easeTo(options, eventData)
    },
    flyTo: function (map, options, eventData) {
        options = Object.assign({
            // These options control the ending camera position: centered at
            // the target, at zoom level 9, and north up.
            center: map_config.MAP_CENTER,
            zoom: zoom,
            bearing: 0,
            // These options control the flight curve, making it move
            // slowly and zoom out almost completely before starting
            // to pan.
            speed: 0.8, // make the flying slow
            curve: 1, // change the speed at which it zooms out
            // This can be any easing function: it takes a number between
            // 0 and 1 and returns another number between 0 and 1.
            easing: function(t) {
                return t;
            }
        }, options)
        map.flyTo(options, eventData)
    },
    fitBounds: function (map, bounds, options, eventData) {
        options = Object.assign({
            // These options control the ending camera position: centered at
            // the target, at zoom level 9, and north up.
            padding: {top: 10, bottom:25, left: 15, right: 5},
            linear: false,
            easing: function(t) {
                return t;
            },
            offset: [0,0],
            maxZoom: 16
        }, options)
        map.fitBounds(bounds, options)
    },
    addmapDragMarker : function(options,callback) {

        options =  Object.assign({
            maps:map,//地图对象
            lng:'',//经度
            lat:'',//纬度
            markerType:'all',//图标类型
            imgType:'poi',//图片
            width:24,//容器宽度
            height:24,//容器高度
            title:'',//marker名称
            item:{},//marker信息
            ext:{},//扩展信息
        }, options);

        const img = this.Img[options.imgType];
        if (options.lng && options.lat) {
            const html = document.createElement('div');
            html.title = options.title;
            if (options.markerType=='c3') {
                html.className = "animation";
                html.style.cssText = ' background-image:url('+img+');width:'+options.width+'px;height:'+options.height+'px;cursor:pointer;background-size: cover;'
            }else{
                html.style.cssText = ' background:url('+img+') no-repeat;width:'+options.width+'px;height:'+options.height+'px;cursor:pointer'
            }
            const marker = new mapboxgl.Marker({
                element:html,
                draggable: true
            })
                .setLngLat([options.lng,options.lat])
                .addTo(options.maps);
            marker.on("dragend", function(e){
                if (callback) {
                    var lngLat = marker.getLngLat();
                    callback(e, lngLat,options.item);
                };
            });

            const obj = {
                marker:marker,
                type:options.markerType
            };
            this.param.markers.push(obj);
        }else{
            _this.$message.error('经纬度缺失');
        }
    },
    addMapDragMarker : function(options,callback) {
        options =  Object.assign({
            maps:map,//地图对象
            lng:'',//经度
            lat:'',//纬度
            markerType:'all',//图标类型
            imgType:'poi',//图片
            width:24,//容器宽度
            height:24,//容器高度
            title:'',//marker名称
            item:{},//marker信息
            ext:{},//扩展信息
        }, options);
        const img = this.Img[options.imgType];
        if (options.lng && options.lat) {
            const html = document.createElement('div');
            html.title = options.title;
            if (options.markerType=='c3') {
                html.className = "animation";
                html.style.cssText = ' background-image:url('+img+');width:'+options.width+'px;height:'+options.height+'px;cursor:pointer;background-size: cover;'
            }else{
                html.style.cssText = ' background:url('+img+') no-repeat;width:'+options.width+'px;height:'+options.height+'px;cursor:pointer'
            }
            const marker = new mapboxgl.Marker({
                element:html,
                draggable: true
            })
                .setLngLat([options.lng,options.lat])
                .addTo(options.maps);
            marker.on("dragend", function(e){
                if (callback) {
                    var lngLat = marker.getLngLat();
                    callback(e, lngLat,options.item,options.imgType,options.title);
                };
            });

            const obj = {
                marker:marker,
                type:options.markerType
            };
            this.param.markers.push(obj);
        }else{
            _this.$message.error('经纬度缺失');
        }
    },
    removeMarkersID: function(type,id) {
        var _this = this
        var markers = this.param.markers
        var _index = []
        var k = 0
        if (markers.length > 0) {
            for (var i = 0; i < markers.length; i++) {
                if (type) {
                    if (markers[i].type === type &&markers[i].id==id) {
                        markers[i].marker.remove()
                        _index.push(i)
                    }
                } else {
                    markers[i].marker.remove()
                    this.param.markers = []
                    _index.push(i)
                }
            }
            for (var j in _index) {
                markers.splice(_index[j] - k, 1)
                k++
            }
        }
    },
    addmapLineAndDir: function(options) {
        options = Object.assign({
            maps: map, //地图对象
            type: 'line',
            id: 'line',
            lines: [],
            color: 'red',
            strokeWeight: 8,
            opacity: 0.8,
            visibility: 'visible',
            dasharray: [1000000, 0],
            arrow: false,
            minzoom: 3
        }, options);
        // console.log(options)
        if (options.lines.length == 0) {
            _this.$message.error('经纬度缺失');
            return
        };
        var geojson = {
            "type": "FeatureCollection",
            "features": [{
                "type": "Feature",
                "geometry": {
                    "type": "LineString",
                    "coordinates": options.lines
                }
            }]
        };
        options.maps.addLayer({
            "id": options.id,
            "type": "line",
            "source": {
                "type": "geojson",
                "data": geojson
            },
            "minzoom": options.minzoom,
            "layout": {
                "line-join": "miter",
                "line-cap": "square",
                "visibility": options.visibility
            },
            "paint": {
                "line-color": options.color,
                "line-width": options.strokeWeight,
                "line-opacity": options.opacity,

                "line-dasharray": options.dasharray

            }
        });
        if (options.arrow) {
            options.maps.addLayer({
                "id": options.id + 1,
                "type": "line",
                "source": {
                    "type": "geojson",
                    "data": geojson
                },
                "minzoom": options.minzoom,

                "paint": {
                    "line-width": options.strokeWeight,
                    "line-pattern": 'dir',

                }
            });
        };
        var obj = {
            type: options.type,
            layers: options.id
        }

        this.param.layers.push(obj);
        return obj;
    },
    addMapLineOrMulAndDir: function(options,callback,hoverCallback) {
		options = Object.assign({
			maps: map, //地图对象
			type: 'line',
			id: 'line',
			lines: [],
			color: 'red',
			strokeWeight: 8,
			opacity: 0.8,
			visibility: 'visible',
			dasharray: [1000000, 0],
			arrow: false,
			minzoom: 3,
            coordinatesType: "LineString"
		}, options);
		if (options.lines.length == 0) {
			_this.$message.error('经纬度缺失');
			return
		};
		var geojson = {
			"type": "Feature",
            "geometry": {
                "type": options.coordinatesType,
                "coordinates": options.lines
            }
		};
        if (options.highlight) {
            options.maps.addLayer({
                "id": options.id+'highlight',
                "type": "line",
                "source": {
                    "type": "geojson",
                    "data": geojson
                },
                "layout": {
                    "line-join": "round",
                    "line-cap": "round"
                },
                "paint": {
                    "line-color": options.color,
                    "line-width": options.highlightStrokeWeight,
                    "line-opacity": options.highlightOpacity
                }
            });
        }
		options.maps.addLayer({
			"id": options.id,
			"type": "line",
			"source": {
				"type": "geojson",
				"data": geojson
			},
			"minzoom": options.minzoom,
			"layout": {
				"line-join": "miter",
				"line-cap": "square",
				"visibility": options.visibility
			},
			"paint": {
				"line-color": options.color,
				"line-width": options.strokeWeight,
				"line-opacity": options.opacity,
				"line-dasharray": options.dasharray
			}
		});
		if (options.arrow) {
			options.maps.addLayer({
				"id": options.id + 1,
				"type": "line",
				"source": {
					"type": "geojson",
					"data": geojson
				},
				"minzoom": options.minzoom,
				"paint": {
					"line-width": options.strokeWeight,
					"line-pattern": 'dir',
				}
			});
		};
        
		var obj = {
			type: options.type,
			layers: options.id
		}

		this.param.layers.push(obj);
		if(callback) {
			//console.log("添加了点击事件",options.id,options.type)
			options.maps.on('click', options.id, function(e) {
				callback(e,options.item)
			})
		}
        if(hoverCallback){
            const popup = new mapboxgl.Popup({
                closeButton: false,
                closeOnClick: false
            });
            options.maps.on('mouseenter', options.id, (e) => {
                options.maps.getCanvas().style.cursor = 'pointer';
                var htmlStr = '';
                options.dataheader.forEach( i => {
                    if( options.item[i.fieldName] ){
                        var value = options.item[i.fieldName];
                        if( i.dictionaryTypeList && value ) {
                            var list = i.dictionaryTypeList.filter((dt) => {
                                return dt.code == value
                            });
                            if( list.length > 0 ){
                                value = list[0].desc;
                            }else{
                                value = null;
                            }
                        }
                        if( value ){
                            htmlStr += `<li>${ i.chnName }: ${ value }</li>`;
                        }
                    } 
                });
                var html = `<div class="inner inner_fuse">
                    <h4>路段详情</h4>
                    <div class='inner_fuse_con'>
                        <ul>
                                ${htmlStr}
                        </ul>
                    </div>
                `
                popup.setLngLat([e.lngLat.lng,e.lngLat.lat]).setHTML(html).addTo(options.maps);
            });
            options.maps.on('mouseleave', options.id, () => {
                options.maps.getCanvas().style.cursor = '';
                popup.remove();
            });
        }

		return obj;
    },
    removeLayersID: function(maps, type,id) {
        var layers = this.param.layers
        var _index = []
        var k = 0
        if (layers.length > 0) {
            for (var i = 0; i < layers.length; i++) {
                if (type) {
                    if (layers[i].type === type &&layers[i].layers == id ) {
                        maps.removeLayerAndSource(layers[i].layers)
                        maps.removeLayerAndSource(layers[i].layers + 1)
                        maps.removeLayerAndSource(layers[i].layers + 'highlight')
                        _index.push(i)
                    }
                } else {
                    maps.removeLayerAndSource(layers[i].layers)
                    maps.removeLayerAndSource(layers[i].layers + 1)
                    maps.removeLayerAndSource(layers[i].layers + 'highlight')
                    _index.push(i)
                    // this.param.layers = []
                }
            }
            for (var j in _index) {
                layers.splice(_index[j] - k, 1)
                k++
            }
        }
    },
    addPolygon: function(options, callback) {
        options = Object.assign({
            maps: map, // 地图对象
            type: 'Polygon',
            id: 'Polygon',
            gons: [],
            color: 'red',
            opacity: 0.8,
            item: null,
            index: null
        }, options)

        if (options.gons.length == 0) {
            _this.$message.error('经纬度缺失')
            return
        }
        var geojson = {
            'type': 'Feature',
            'geometry': {
                'type': 'Polygon',
                'coordinates': [options.gons]
            }

        }

        options.maps.addLayer({
            'id': options.id,
            'type': 'fill',
            'source': {
                'type': 'geojson',
                'data': geojson
            },
            'maxzoom': 24,
            'paint': {
                'fill-color': options.color,
                'fill-outline-color': '#fff',
                'fill-opacity':options.opacity
            }
        })
        var obj = {
            type: options.type,
            layers: options.id
        }

        this.param.layers.push(obj)
        options.maps.on('click', options.id, function() {
            if (callback) {
                callback(options.item, options.gons)
            }
        })
    },
    addPolygonDir: function(options, callback) {
        options = Object.assign({
            maps: map, // 地图对象
            type: 'Polygon',
            id: 'Polygon',
            geojson: [],
            color: 'red',
            opacity: 0.8,
            outColor:'#fff',
            item: null,
            index: null
        }, options)

        if (options.geojson.length == 0) {
            _this.$message.error('经纬度缺失')
            return
        }
        var geojson = {
            'type': 'Feature',
            'geometry': {
                'type': 'Polygon',
                'coordinates': [options.geojson]
            }

        }

        options.maps.addLayer({
            'id': options.id,
            'type': 'fill',
            'source': {
                'type': 'geojson',
                'data': geojson
            },
            'maxzoom': 24,
            'minzoom': 17,
            'paint': {
                'fill-color': options.color,
                // 'fill-outline-color': options.outColor,
                'fill-opacity': options.opacity
            }
        })
        var obj = {
            type: options.type,
            layers: options.id
        }

        this.param.layers.push(obj)
        options.maps.on('click', options.id, function() {
            if (callback) {
                callback(options.item, options.index)
            }
        })
    },
    addmapsLines: function(options) {

        options = Object.assign({
            maps: map, //地图对象
            type: 'line',
            id: 'line',
            lines: [],
            color: 'red',
            strokeWeight: 8,
            opacity: 0.8,
            visibility: 'visible',
            dasharray: [1000000, 0],
            arrow: false,
            minzoom: 3
        }, options);
        // console.log(options)
        if (options.lines.length == 0) {
            _this.$message.error('经纬度缺失');
            return
        };
        var geojson = {
            "type": "FeatureCollection",
            "features": [{
                "type": "Feature",
                "geometry": {
                    "type": "LineString",
                    "coordinates": options.lines
                }
            }]
        };


        options.maps.addLayer({
            "id": options.id,
            "type": "line",
            "source": {
                "type": "geojson",
                "data": geojson
            },
            "minzoom": options.minzoom,
            "layout": {
                "line-join": "miter",
                "line-cap": "square",
                "visibility": options.visibility
            },
            "paint": {
                "line-color": options.color,
                "line-width": options.strokeWeight,
                "line-opacity": options.opacity,
                "line-dasharray": options.dasharray
            }
        });
        if (options.arrow) {
            options.maps.addLayer({
                "id": options.id + 1,
                "type": "line",
                "source": {
                    "type": "geojson",
                    "data": geojson
                },
                "minzoom": options.minzoom,

                "paint": {
                    "line-width": options.strokeWeight,
                    "line-pattern": 'dir',

                }
            });
        };
        var obj = {
            type: options.type,
            layers: options.id
        }

        this.param.layers.push(obj);
        return obj;
    },
    addmapsLabel: function(options,isNumber, callback) {
        options = Object.assign({
            maps: map, //地图对象
            bgcolor: '#458e25',
            shadowcolor: null,
            lng: '', //经度
            lat: '', //纬度
            name: '',
            type: 'label',
            index: null,
            txtColor:"#fff",
            item: {}, //信息
        }, options);
        var html = document.createElement('div');
        var span = document.createElement("span");
        if(isNumber){
            var b = document.createElement("b");
            b.innerHTML = options.index + 1;
            b.style.cssText="background: rgb(241, 59, 38);display: inline-block;width: 16px;text-align: center;font-size:12px;color:"+options.txtColor;
            html.appendChild(b);
        }
        span.innerHTML = options.name;
        span.style.cssText = 'z-index:1000;display:inline-block;background:' + options.bgcolor + ';cursor:pointer;padding:0 5px;font-size:12px;color:'+options.txtColor;

        html.appendChild(span);



        var marker = new mapboxgl.Marker(html)
            .setLngLat([options.lng, options.lat])
            .addTo(options.maps);
        html.addEventListener('click', function() {
            if (callback) {
                callback(options.item, options.index);
            }

        })

        var obj = {
            marker: marker,
            type: options.type
        }
        this.param.markers.push(obj)



    },
    addmapsPolygon: function (options, callback) {
		options = Object.assign({
			maps: map, //地图对象
			type: 'Polygon',
			id: 'Polygon',
			gons: [],
			color: 'red',
			opacity: 0.8,
			item: null,
			index: null,
			ind: null
		}, options);
		if (options.gons.length == 0) {
			_this.$message.error('经纬度缺失');
			return
		};
		var geojson = {

			"type": "Feature",
			"geometry": {
				"type": "Polygon",
				"coordinates":
					options.gons

			}
		};


		var layer = options.maps.addLayer({
			'id': options.id,
			'type': 'fill',
			'source': {
				'type': 'geojson',
				'data': geojson
			},
			'layout': {},
			'paint': {
				'fill-color': options.color,
				'fill-opacity': options.opacity,
			}
		});
		var obj = {
			type: options.type,
			layers: options.id
		}

		this.param.layers.push(obj);
		options.maps.on('click', options.id, function () {
			if (callback) {
				callback(options.item, options.index,options.type,options.ind)
			}

		})

	},
    addmapsLine: function (options) {
		options = Object.assign({
			maps: map, //地图对象
			type: 'line',
			id: 'line',
			lines: [],
			color: 'red',
			strokeWeight: 8,
			opacity: 0.8,
			visibility: 'visible',
			dasharray: [1000000, 0],
			arrow: false,
			minzoom: 3
		}, options);
		// console.log(options)
		if (options.lines.length == 0) {
			_this.$message.error('经纬度缺失');
			return
		};
		var featuresOpt = [];
		for(var i = 0; i < options.lines.length; i++){
			var obj = {
				"type": "Feature",
				"geometry": {
					"type": "LineString",
					"coordinates": options.lines[i]
				}
			};
			featuresOpt.push(obj)
		}
		var geojson = {
			"type": "FeatureCollection",
			"features": featuresOpt
		};
        let paint = {};
        if( options.dasharray ){
            paint = {
				"line-color": options.color,
				"line-width": options.strokeWeight,
				"line-opacity": options.opacity,
				"line-dasharray": options.dasharray
			}
        }else{
            paint = {
				"line-color": options.color,
				"line-width": options.strokeWeight,
				"line-opacity": options.opacity,
			}
        }


		options.maps.addLayer({
			"id": options.id,
			"type": "line",
			"source": {
				"type": "geojson",
				"data": geojson
			},
			"minzoom": options.minzoom,
			"layout": {
				"line-join": "miter",
				"line-cap": "square",
				"visibility": options.visibility
			},
			"paint": paint
		});
		if (options.arrow) {
			options.maps.addLayer({
				"id": options.id + 1,
				"type": "line",
				"source": {
					"type": "geojson",
					"data": geojson
				},
				"minzoom": options.minzoom,

				"paint": {
					"line-width": options.strokeWeight,
					"line-pattern": 'dir',

				}
			});
		};
		var obj = {
			type: options.type,
			layers: options.id
		}

		this.param.layers.push(obj);
		return obj;
	},

}

/* eslint-disable */
