if (typeof WebSocket == "undefined") {
    alert("浏览器不支持Websocket")
}

function connect(url, params) {
    let socket = new WebSocket(url)
    //open
    socket.onopen = function () {
        if (params) {
            send(socket, params)
        }
    }
    socket.onerror = function () {
        console.log('socket error...')
        setTimeout(function () {
            // 重连
            connect(url, params)
        }, 5000)
    }
    //error
    socket.onclose = function (error) {
        console.log('socket close...')
    }
    return socket
}

function close(socket) {
    if (socket) {
        socket.close()
    }
}

function send(socket, data) {
    if (socket) {
        let params = JSON.stringify(data)
        socket.send(params)
    }
}

export {connect, close, send}
