let mMap = null,
  honglvdengModel = null,
  lightModels = [];
export default {
  name: "mixinLightModel",
  components: {},
  data() {
    return {
    };
  },
  props: [],
  watch: {},
  mounted() {
  },
  beforeDestroy() {
  },
  methods: {
    mRemoveLight(){
      this.removeLightModels()
    },
    loadLightModel(map) {
      mMap = map
      window.tb.loadObj(
        {
          obj: `gltf/honglvdeng.glb`,
          units: "meters",
          cloned: true,
          adjustment: { x: 0, y: 1, z: 0 },
          type: "gltf",
          scale: 0.02 * (map_config.lightScale || 1),
          bbox: false,
        },
        (model) => {
          honglvdengModel = model;
        }
      );
    },
    addLightModels(array) {
      for (let [index, item] of array.entries()) {
        let model = honglvdengModel.duplicate();
        model.setCoords(item.location);
        model.userData.data = item;
        model.setRotation({
          x: 90,
          y: 360 - (item.dir - 1) * 45 + 170 - (item.offsetAngle || 0),
          z: 0,
        });
        window.tb.add(model, `lignt${index}`);
        lightModels.push(model);
      }
    },
    removeLightModels() {
      // 层级较小 remove lightModel
      if (lightModels.length) {
        for (let i = 0; i < lightModels.length; i++) {
          window.tb?.clear(`light${i}`, true);
        }
        window.tb?.update();
        lightModels = [];
      }
    },
    mCallLight(msg) {
      if (mMap && window.tb && msg[0] && msg[0].dirLampGroupMap) {
        // // 定义四个方向的红绿灯以及坐标
        // let lights = [
        // 	{ location: [112.9638268421748, 28.188574703104123], dir: 1 },
        // 	// location代表位置 dir代表出口方向（ 1北 2东北 3东 4东南 5南 6西南 7西 8西北）
        // ]
        let lights = map_config.lights || [];
        if (mMap.getZoom() > 18) {
          if (!lightModels.length) {
            this.addLightModels(lights);
          }
          // ws 灯态数据
          // let lightMsg = [
          //   {
          //     dirLampGroupMap: {
          //       1: { 1: "red", 2: "red", 3: "green" },
          //       3: { 1: "red", 2: "red", 3: "green" },
          //       5: { 1: "red", 2: "red", 3: "green" },
          //       7: { 1: "red", 2: "red", 3: "green" },
          //     },
          //   },
          // ];
          let lightMsg = msg;
          // 转换灯态数据 为 可处理数组
          let lightArr = [];
          for (let dir in lightMsg[0].dirLampGroupMap) {
            for (let turn in lightMsg[0].dirLampGroupMap[dir]) {
              let colorString = lightMsg[0].dirLampGroupMap[dir][turn];
              lightArr.push({ dir: dir, turn: turn, color: colorString });
            }
          }
          for (let model of lightModels) {
            // 根据唯一的 dir 匹配到具体的 light model
            let filterLightArr = lightArr.filter((item) => {
              return item.dir == model.userData.data.dir;
            });
            for (let singleL of filterLightArr) {
              model.traverse((child) => {
                if (child.isMesh) {
                  /** 材质名称对应位置
                   * 2：右1
                   * 4: 右2
                   * 3：右3
                   * 7：下1
                   * 6：下2
                   * 5：下3
                   * 8：中1
                   * 9：中2
                   * 10：中3
                   * 11：左1
                   * 12：左2
                   * 13：左3
                   *  */
                  child.material = child.material.clone();
                  switch (singleL.turn) {
                    case "1": // 左转
                      // 左转红灯：glb左侧三个灯组成的灯组 左红 中右不亮
                      if (singleL.color == "red") {
                        if (child.name == "mesh_11") {
                          child.material.color.set("red");
                        }
                        if (
                          child.name == "mesh_12" ||
                          child.name == "mesh_13"
                        ) {
                          child.material.color.set("black");
                        }
                      }
                      if (singleL.color == "yellow") {
                        if (child.name == "mesh_13") {
                          child.material.color.set("yellow");
                        }
                        if (
                          child.name == "mesh_12" ||
                          child.name == "mesh_11"
                        ) {
                          child.material.color.set("black");
                        }
                      }
                      if (singleL.color == "green") {
                        if (child.name == "mesh_12") {
                          child.material.color.set("green");
                        }
                        if (
                          child.name == "mesh_13" ||
                          child.name == "mesh_11"
                        ) {
                          child.material.color.set("black");
                        }
                      }
                      break;
                    case "2": // 直行
                      if (singleL.color == "red") {
                        if (child.name == "mesh_8") {
                          child.material.color.set("red");
                        }
                        if (child.name == "mesh_10" || child.name == "mesh_9") {
                          child.material.color.set("black");
                        }
                      }
                      if (singleL.color == "yellow") {
                        if (child.name == "mesh_10") {
                          child.material.color.set("yellow");
                        }
                        if (child.name == "mesh_8" || child.name == "mesh_9") {
                          child.material.color.set("black");
                        }
                      }
                      if (singleL.color == "green") {
                        if (child.name == "mesh_9") {
                          child.material.color.set("green");
                        }
                        if (child.name == "mesh_10" || child.name == "mesh_8") {
                          child.material.color.set("black");
                        }
                      }
                      break;
                    case "3": // 右转
                      if (singleL.color == "red") {
                        if (child.name == "mesh_2") {
                          child.material.color.set("red");
                        }
                        if (child.name == "mesh_3" || child.name == "mesh_4") {
                          child.material.color.set("black");
                        }
                      }
                      if (singleL.color == "yellow") {
                        if (child.name == "mesh_3") {
                          child.material.color.set("yellow");
                        }
                        if (child.name == "mesh_2" || child.name == "mesh_4") {
                          child.material.color.set("black");
                        }
                      }
                      if (singleL.color == "green") {
                        if (child.name == "mesh_4") {
                          child.material.color.set("green");
                        }
                        if (child.name == "mesh_2" || child.name == "mesh_3") {
                          child.material.color.set("black");
                        }
                      }
                      break;
                    default:
                  }
                }
              });
            }
          }
        } else {
          this.removeLightModels();
        }
      }
    },
  },
};
